# coding: utf-8
from os.path import isdir, isfile, join
from os import makedirs, listdir, rename
from shutil import rmtree
from zipfile import ZipFile

from eoleaaf.parseaaf import main
from eoleaaf.config import path_aaf_complet
from eoleaaf.sambatranslator import SambaToplevel

def _send_error_message(msg, err):
        return dumps({'message': {'type': 'error', 'text': u"Erreur {} {}".format(msg, err)}}).encode()


def aafcomplet(filename):
    """
    :param filename: fullpath of the archive to unzip
    """
    # the file must exists
    if not isfile(filename):
        return _send_error_message(u"impossible de trouver le fichier à décompresser", filename)
    # purge the folders
    try:
        if isdir(path_aaf_complet):
            rmtree(path_aaf_complet)
        makedirs(path_aaf_complet)
    except Exception as err:
        return _send_error_message(u"à la création du répertoire de travail", err)
    # unzip the files
    try:
        zip_ref = ZipFile(filename, 'r')
        zip_ref.extractall(path_aaf_complet)
        zip_ref.close()
        # move the files in path_aaf_complet if there is any subfolder
        for fname in listdir(path_aaf_complet):
            fullname = join(path_aaf_complet, fname)
            if isdir(fullname):
                for subfname in listdir(fullname):
                    rename(join(fullname, subfname), join(path_aaf_complet, subfname))
    except Exception as err:
        return _send_error_message(u"à la décompression des fichiers", err)
    try:
        # imports the files in mongodb
        main(path_aaf_complet, True)
        ##export TDB_NO_FSYNC=1
        #samba_import = SambaToplevel()
        #samba_import.run()
    except Exception as err:
        return _send_error_message(u"à l'importation des comptes", err)
